#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################
 

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;


&get_setup;
fmspm::check_spamb("modify2.cgi", "header", "$data_dir");
$q = CGI->new;

#################

$default_permissions = 0777;

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") { &start; } 


sub start
{

$gsettings = new_gsettings tseek;

$cid = $q->param('cid'); $cid =~ s/[^0-9]//g;
$lnkid = $q->param('id'); $lnkid =~ s/[^0-9]//g;
$lnkpassword = $q->param('password'); 
		
		if ($lnkpassword =~ /'/) { &wrong_ps; }
		if ($lnkpassword =~ /\\/) { &wrong_ps; }

		if ($lnkid =~ /'/) { &wrong_ps; }
		if ($lnkid =~ /\\/) { &wrong_ps; }

		if ($cid =~ /'/) { &wrong_ps; }
		if ($cid =~ /\\/) { &wrong_ps; }


if ($gsettings->{addurl_reg_system} eq "Yes") ### IF REGISTRATION SYSTEM IN USE
	{
	$cpuserid = pseek::accesscheck($q->param('rgs_user'), $q->param('rgs_pass'));
	
		### CHECK IF USER ACCOUNT IS LINKED TO URL TO MODIFY
		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
		
		$wsql = "SELECT * FROM links WHERE lnkid = '$lnkid' and userid = '$cpuserid'";
		$sth = $dbh->prepare($wsql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
		$rows = $sth->rows();
		
		if ($rows < 1) ### DISPLAY 'You are logged in but you may not modify this link as it does not belong to you.
			{

			$modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_problem.html");
			
				$mdtext = pseek::get_file_contents("$data_dir/modify2.txt"); 
				@mtext = split (/\n/, $mdtext);
				
			
			$modify_template =~ s/%%problem%%/$mtext[9]/g;
			$modify_template =~ s/!!problem!!/$mtext[9]/g;
			
			$modify_template = pseek::ts_insert_template_includes($modify_template);
			$modify_template = pseek::fill_vars($modify_template); 
			$modify_template =~ s/!!scripts_url!!/$script_url/g;
			
			$sth->finish;
			$dbh->disconnect;
			
			print $modify_template;
			exit;
			}
		
		$sth->finish;
		$dbh->disconnect;

	}
	else ### CHECK IF PASSWORD REQUIRED OR CORRECT
	{

		if (($gsettings->{modif_password} ne "No") and ($lnkpassword eq ""))
		{
		&wrong_ps; ### IF NOTHING ENTERED INTO THE MODIFY PASSWORD BOX
		}

	for ($ms = 0; $ms < length($lnkpassword); $ms++) 
		{
		$oneletter = substr($lnkpassword, $ms, 1);
		if (($oneletter =~ /[0-9a-zA-Z]/))
			{
			$textfound = "true";
			}
		}

		if ($textfound ne "true"){&wrong_ps;}
		
	}

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


##### EXTRA FIELD/KEY OPPS

$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


### GET CATEGORY
if (($gsettings->{modif_password} ne "No") and ($gsettings->{addurl_reg_system} ne "Yes"))
	{
	$psql = "AND lnkpassword = '$lnkpassword'";
	}

#print "==> SELECT * FROM links WHERE lnkid = '$lnkid' $psql";
$wsql = "SELECT * FROM links WHERE lnkid = '$lnkid' $psql";

$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
$rows = $sth->rows();


if ($rows < 1)
	{
	$sth->finish;
	$dbh->disconnect;
	&wrong_ps;
	}



$todaytime = time();

while ( @row = $sth->fetchrow() )
	{

		#### GET MODIFY LINK TEMPLATE
		if ($gsettings->{addurl_reg_system} eq "Yes")
		{
			if ($row[21] < 1) { $row[21] = "9999999999999999999999"; }
			if (($row[13] > 0) and ($row[21] > $todaytime))
				{
				$modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_editp.html");
				$premlink = "true";
				}
				else
				{
				$modify_template = pseek::get_file_contents("$data_dir/rgs_modify_link_edit.html");
				}
		}
		else
		{
				if ($row[21] < 1) { $row[21] = "9999999999999999999999"; }
				if (($row[13] > 0) and ($row[21] > $todaytime))
					{
					$modify_template = pseek::get_file_contents("$data_dir/modify_link_editp.html");
					$premlink = "true";
					}
					else
					{
					$modify_template = pseek::get_file_contents("$data_dir/modify_link_edit.html");
					}
		}



		if ($premlink eq "true")
			{
			$form_crit = qq[<input type="hidden" name="premium" value="true"></form>];
			$modify_template =~ s/<\/form>/$form_crit/gi;
			}



		$modify_template =~ s/!!scripts_url!!/$script_url/g;
	
		if ($gsettings->{searchmeth} eq "fulltext")
		{
		$modify_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
		}
		else
		{
		$modify_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
		}


	$modify_template =~ s/!build_url!/$web_url/g;
	$modify_template =~ s/!!build_url!!/$web_url/g;




	###########
	
	$lnkid = $row[0];
	$title = $row[2];
	$description = $row[3];
	$url = $row[5];
	$keywords = $row[4];
	$name = $row[8];
	$email = $row[9];
	$hits = $row[12]; if ($hits eq "") { $hits = 0; }
	
	$modify_recip = $row[25];
	
	$image_ext = $row[6];
	
	if ($gsettings->{modif_password} ne "No") 
		{
		$lnkpassword = $row[22];
		}



	##### EXTRA FIELD/KEY OPPS
	$kstart = 27;
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $typefield, $req) = split (/\t/, $k_item);
		
		if ($typefield eq "Upload")
			{
			## %%key_file_with_link%%
			$replace_file_name = "%%" . $keyname . "_file_with_link%%";
			
				if ($row[$kstart] ne "") ### IF UPLOAD FIELD HAS AN UPLOADED IMAGE
					{
					$curfile = $keyname . "." . $row[$kstart];
					$curfile = qq[<a href="$web_url/imagefiles/$row[0]/$curfile"  target="_blank">$curfile</a>];
					$modify_template =~ s/$replace_file_name/$curfile/gi;
					$modify_template = &display_inbound_text($modify_template, $keyname . "_no_filename_text", $keyname . "_no_filename_text_end", "BLANK");
					$chboxrep = "%%" . $keyname . "_checkbox%%";
					
					if ($req eq "Yes") ### IF REQUIRED THEN DON'T DISPLAY OPTION TO DELETE FILE
						{
						$modify_template = &display_inbound_text($modify_template, $keyname . "_del_text", $keyname . "_del_text_end", "BLANK");
						$modify_template =~ s/$chboxrep//gi;
						}
						else  ### IF NOT REQUIRED THEN DISPLAY OPTION TO DELETE FILE
						{
						$modify_template = &display_inbound_text($modify_template, $keyname . "_del_text", $keyname . "_del_text_end", "");
						$chboxname = $keyname . "_cbox"; $modify_del_cbox = qq[<input type="checkbox" name="$chboxname" value="Y">];
						$modify_template =~ s/$chboxrep/$modify_del_cbox/gi;
						}
					
					$mod_hid_nm = $keyname . "_hid";
					$mod_hid_values = $mod_hid_values . qq[<input type="hidden" name="$mod_hid_nm" value="$row[$kstart]">];
					}
					else
					{
					$modify_template =~ s/$replace_file_name//gi;
					$modify_template = &display_inbound_text($modify_template, $keyname . "_no_filename_text", $keyname . "_no_filename_text_end", "");
					$modify_template = &display_inbound_text($modify_template, $keyname . "_del_text", $keyname . "_del_text_end", "BLANK");
					$delcheckbox = "%%" . $keyname . "_checkbox%%"; $modify_template =~ s/$delcheckbox//gi;
					}
			
			}
			else
			{
			$modify_template =~ s/%%$keyname%%/$row[$kstart]/gi;
			$modify_template =~ s/!!$keyname!!/$row[$kstart]/gi;
			}
		
		
		$kstart++;
		}
		
	
	
}


if ($mod_hid_values ne "") { $modify_template =~ s/<\/form>/$mod_hid_values<\/form>/gi; }


$modify_template =~ s/%%title%%/$title/gi;

$submissionbox = "<textarea rows=\"5\" name=\"description\" cols=\"29\" style=\"width:100%\">$description</textarea>";
$modify_template =~ s/%%submissionbox%%/$submissionbox/gi;


$notesbox = "<textarea rows=\"5\" name=\"notes\" cols=\"29\" style=\"width:100%\"></textarea>";
$modify_template =~ s/%%notesbox%%/$notesbox/gi;

$modify_template =~ s/%%keywords%%/$keywords/gi;

$modify_template =~ s/%%url%%/$url/gi;

$modify_template =~ s/%%name%%/$name/gi;

$modify_template =~ s/%%email%%/$email/gi;

$modify_template =~ s/%%hits%%/$hits/gi;

$modify_template =~ s/%%password%%/$lnkpassword/gi;


$modify_template =~ s/!!modify_recip!!/$modify_recip/gi;



##### EXTRA FIELD/KEY OPPS

$modify_template =~ s/!!id!!/$lnkid/gi;
$modify_template =~ s/!!cid!!/$cid/gi;
$modify_template =~ s/!!password!!/$lnkpassword/gi;
$modify_template =~ s/!!modify_cgii!!/$script_url\/modify3.cgi/gi;
$modify_template =~ s/!!modify_cgi!!/$script_url\/modify3.cgi/gi;





##### IMAGE DETAILS (STANDARD WITH LINK)

$img_fname = "$web_dir/imagefiles/$lnkid" . "." . $image_ext;

if (($image_ext ne "") and (-e "$img_fname"))
	{
	
	### DISPLAY IMAGE AND REMOVE NO IMAGE TEXT
	if ((lc($image_ext) eq "tif") or (lc($image_ext) eq "png") or (lc($image_ext) eq "jpg") or (lc($image_ext) eq "jpeg") or (lc($image_ext) eq "gif") or (lc($image_ext) eq "bmp"))
		{ 
	
			if (($gsettings->{image_width} > 0) and ($gsettings->{image_height} > 0))
				{
				$width = $gsettings->{image_width};
				$height = $gsettings->{image_height};
				$imgwh = qq[width="$width" height="$height"];
				}
	
			$rfnm = "$lnkid" . "." . $image_ext;
			$imghtmltag = qq[<img src="$web_url/imagefiles/$rfnm" $imgwh>];
			$modify_template =~ s/%%image%%/$imghtmltag/gi;
		
		}
		else
		{
			$rfnm = "$lnkid" . "." . $image_ext;
			$imghtmltag = qq[<a href="$web_url/imagefiles/$rfnm">$rfnm</a>];
			$modify_template =~ s/%%image%%/$imghtmltag/gi;
		
		}

	if ($modify_template =~ m/\[imgtext\]/g) { $img_text_start = pos($modify_template); }
	if ($modify_template =~ m/\[endimgtxt\]/g) { $img_text_end = pos($modify_template); }
	
	if (($img_text_start > 0) and ($img_text_end > 0))
		{
		$chunk1 = substr($modify_template, 0, ($img_text_start - 9));
		$chunk2 = substr($modify_template, $img_text_end, length($modify_template) - $img_text_end);
		$modify_template = $chunk1 . $chunk2;
		}
	
	
	#### DISPLAY DELETE IMAGE OPTION
	
	#[delbtext]Delete Image?[enddelbtext] %%delete_checkbox%%
	
	$modify_template =~ s/\[delbtext\]//gi;
	$modify_template =~ s/\[enddelbtext\]//gi;
	
	$del_cbox = qq[<input type="checkbox" name="delimgbox" value="Y">];
	$modify_template =~ s/%%delete_checkbox%%/$del_cbox/gi;
	}
	else
	{
	
	$modify_template =~ s/\[imgtext\]//gi;
	$modify_template =~ s/\[endimgtxt\]//gi;
	$modify_template =~ s/%%image%%//gi;

	### REMOVE DELETE IMAGE BOX BECAUSE THERE IS NO IMAGE TO DELETE
	
	if ($modify_template =~ m/\[delbtext\]/g) { $del_text_start = pos($modify_template); }
	if ($modify_template =~ m/\[enddelbtext\]/g) { $del_text_end = pos($modify_template); }
	
	if (($del_text_start ne "") and ($del_text_end ne ""))
		{
		$chunk1 = substr($modify_template, 0, ($del_text_start - 10));
		$chunk2 = substr($modify_template, $del_text_end, length($modify_template) - $del_text_end);
		$modify_template = $chunk1 . $chunk2;
		}
	
	$modify_template =~ s/%%delete_checkbox%%//gi;
	}





$sth->finish;
$dbh->disconnect;


$modify_template = pseek::ts_insert_template_includes($modify_template);
$modify_template = pseek::fill_vars($modify_template); 

print  $modify_template;

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}


sub wrong_ps
{

	$modify_template = pseek::get_file_contents("$data_dir/modify_link_problem.html");
	$modify_template = pseek::ts_insert_template_includes($modify_template);
	$modify_template =~ s/!!scripts_url!!/$script_url/g;


if ($gsettings->{searchmeth} eq "fulltext")
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
	}
	else
	{
	$modify_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
	}
	
	$modify_template =~ s/!build_url!/$web_url/g;
	$modify_template =~ s/!!build_url!!/$web_url/g;
	$problm = "The password you entered was incorrect.";
	$modify_template =~ s/%%problem%%/$problm/gi;
	$modify_template = pseek::fill_vars($modify_template); 
	print $modify_template; exit; 

}



sub display_inbound_text
{

my ($worktemplate, $start_crit, $end_crit, $blankval) = @_;


if ($blankval eq "BLANK")
	{
	if ($worktemplate =~ m/\[$start_crit\]/g)
		{
		$r1 = pos($worktemplate);
		$start_tmpl = substr($worktemplate, 0, $r1 - length($start_crit) - 2);
		}

	if ($worktemplate =~ m/\[$end_crit\]/g)
		{
		$r2 = pos($worktemplate);
		$end_tmpl = substr($worktemplate, $r2, length($worktemplate) - $r);
		}
		
		if (($start_tmpl ne "") and ($end_tmpl ne ""))
			{
	 		$tmpl_return = $start_tmpl . $end_tmpl;
	 		}
	 		else
	 		{
	 		$tmpl_return = $worktemplate;
	 		}
	}
else
	{
	$worktemplate =~ s/\[$start_crit\]//gi;
	$worktemplate =~ s/\[$end_crit\]//gi;
	$tmpl_return = $worktemplate;
	}
	
return ($tmpl_return);

}



sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

